/*-------------------------------------------------------------------------
	Copyright (C) 2008-2009 American Megatrends Inc.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.		     
-------------------------------------------------------------------------*/
#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/delay.h>
#include <linux/slab.h>
#include <linux/init.h>
#include <linux/interrupt.h>
#include <linux/wait.h>
#include <asm/io.h>
#include <asm/irq.h>
#include "i2c-data.h"
#include "i2c-hardware.h"

struct i2c_vsc_data vsc_data_ptr[BUS_COUNT];

void i2c_init_internal_data(int bus)
{
/* JM: This driver supports master mode only. No need for slave mode support. */
#if 0
	int i;

	vsc_data_ptr[bus].Linear_SlaveRX_len = 0;
	vsc_data_ptr[bus].Linear_SlaveRX_index = 0;

	for (i=0; i<MAX_FIFO_LEN; i++) {
		vsc_data_ptr[bus].SlaveRX_len[i] = 0;
		vsc_data_ptr[bus].SlaveRX_index[i] = 0;
	}
	vsc_data_ptr[bus].SlaveRX_Writer = 0;
	vsc_data_ptr[bus].SlaveRX_Reader = 0;
	vsc_data_ptr[bus].SlaveRX_Entries = 0;
#endif
	
	/* Initialize locks, queues and variables */
	spin_lock_init (&vsc_data_ptr[bus].data_lock);
	init_waitqueue_head (&(vsc_data_ptr[bus].vsc_wait)); 

	vsc_data_ptr[bus].TX_len = 0;
	vsc_data_ptr[bus].TX_index = 0;

	vsc_data_ptr[bus].MasterRX_len = 0;
	vsc_data_ptr[bus].MasterRX_index = 0;


	vsc_data_ptr[bus].state = STATE_IDLE;

	return;
}
