/*
 * Carsten Langgaard, carstenl@mips.com
 * Copyright (C) 1999,2000 MIPS Technologies, Inc.  All rights reserved.
 *
 *  This program is free software; you can distribute it and/or modify it
 *  under the terms of the GNU General Public License (Version 2) as
 *  published by the Free Software Foundation.
 *
 *  This program is distributed in the hope it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  59 Temple Place - Suite 330, Boston MA 02111-1307, USA.
 *
 * Putting things on the screen/serial line using YAMONs facilities.
 */
#include <linux/init.h>
#include <linux/kernel.h>
#include <asm/mach-vsc452/vsc452.h>
#include <asm/addrspace.h>


int prom_putchar(char c)
{
	unsigned int status;
	volatile u32 * statAddr = (u32 *)KSEG1ADDR(SYS_SITS);
	volatile u32 * txDataAddr = (u32 *)KSEG1ADDR(SYS_SITD);

	while (1)
	{
		status = *statAddr;

		if (status & SYS_SITS_TXR)
		{
			*txDataAddr = (unsigned int)c;
			return 1;
		}
	}

	return 0;
}

