/* ------------------------------------------------------------------------- */
/* Copyright (C) 2009 American Megatrends Inc.
 *
 * ECC Device Driver Header File                                             */
/* ------------------------------------------------------------------------- */

#define INT_OBSERVE_REG 				((volatile unsigned long)0xB02008FC)
#define ECC_INTERRUPT_BIT 				1 << 7

#define ECC_CORRECTABLE_ERR_COUNT_REG	0xB0200F30
#define ECC_ERR_SYNDROME_REG			0xB0200F34
#define ECC_UNCORRECTABLE_ERR_ADDR_REG	0xB0200F38
#define ECC_CORRECTABLE_ERR_ADDR_REG	0xB0200F3C
#define ECC_OUT_OF_RANGE_ADDR_REG		0xB0200F40
#define ECC_UNCORRECTABLE_ERR_INFO_REG	0xB0200F44
#define ECC_INTERRUPT_STATUS_REG		0xB0200F48
#define ECC_INTERRUPT_MASK_REG			0xB0200F4C
#define ECC_CNTRL_REG					0xB0200F5C
#define ECC_INTERRUPT_PRIORITY_REG		0xB0200F60
#define ECC_CNTRL_2_REG					0xB0200F68

#define ECC_DDR_START_OPERATION			0xB0200F04
#define KCS2_STATUS_REG					0xB0200E04
#define KCS2_DATA_REG					0xB0200E00
#define VSC_POS_REG						0xB02008A8
#define SRAM_INTERFACE_REG				0xB0005000
#define FORCE_HARDWARE_RESET_REG		0xB02008F4

#define ENABLE_COR_UNCOR_OUT_ADD_ERR	0xFFFFFFF4
#define ENABLE_OUT_OF_RANGE_ADDR_ERR	0xFFFFFFF7
#define ENABLE_COR_AND_UNCOR_ERR		0xFFFFFFFC
#define ENABLE_CORRECTABLE_ERR			0xFFFFFFFD
#define ENABLE_UNCORRECTABLE_ERR		0xFFFFFFFE
#define MASK_ALL_INTERRUPT				0xFFFFFFFF

#define CLEAR_CORRECTABLE_ERR_COUNTER	0xFFFF0000
#define CLEAR_UNCORRECTABLE_ERR_COUNTER	0x0000FFFF
#define CLEAR_OUT_OF_RANGE_ERR_COUNTER	0xFFFF0000

#define DISABLE_ECC_INTERRUPT_FOR_ALL	0x0003FFFF
#define ENABLE_ECC_INTERRUPT_FOR_ALL	0xFFFC0000
#define ENABLE_ECC_INTERRUPT_FOR_ETH1	0xFFFCFFFF
#define ENABLE_ECC_INTERRUPT_FOR_ETH0	0xFFFF3FFF
#define ENABLE_ECC_INTERRUPT_FOR_USB	0xFFFFCFFF
#define ENABLE_ECC_INTERRUPT_FOR_DES	0xFFFFF3FF
#define ENABLE_ECC_INTERRUPT_FOR_AES	0xFFFFFCFF
#define ENABLE_ECC_INTERRUPT_DVC_SDRAM	0xFFFFFF7F
#define ENABLE_ECC_INTERRUPT_DVC_2XDMA	0xFFFFFFBF
#define ENABLE_ECC_INTERRUPT_DVC_DMA	0xFFFFFFDF
#define ENABLE_ECC_INTERRUPT_DVC_RD		0xFFFFFFEF
#define ENABLE_ECC_INTERRUPT_DVC_W		0xFFFFFFF7
#define ENABLE_ECC_INTERRUPT_GRAPHIC_R	0xFFFFFFFB
#define ENABLE_ECC_INTERRUPT_G_CORE		0xFFFFFFFD
#define ENABLE_ECC_INTERRUPT_MIPS_CORE	0xFFFFFFFE

#define OUT_OF_RANGE_ADDR_STATUS_BIT	1 << 3
#define CORRECTABLE_ERR_STATUS_BIT		1 << 1
#define UNCORRECTABLE_ERR_STATUS_BIT	1 << 0

#define INJECT_ERROR					1
#define CREATE_FILE						2

#define FORCE_SYSTEM_RESET				1 << 7
#define FORCE_SOFT_RESET				1 << 6
#define CLEAR_IBF_OBF_FLAG				0x00
#define SP_SELF_REPAIR					0x09
#define SET_OBF_FLAG					0x01
#define UNCORRECTABLE_ECC_PANIC			0xD6
#define OEM_RESET_PANIC					0x52
#define DDR_START_MEM_INIT				0x01
#define MASK_CORRECTABLE_ERROR			0xFFFF

#define RESET_ERROR_INJECTION			0x00FFFFFF
#define INJECT_UNCORRECTABLE_ERROR		0x00FF1305
#define INJECT_CORRECTABLE_ERROR		0x00FFFF05
#define UNCORRECTABLE_ERROR				0
#define CORRECTABLE_ERROR				1

#define ECC_IRQ_NUM						4
#define ATTRIB_NAME_SIZE				10
#define NONE							0
#define AND								1
#define OR								2
#define SLEEP							0
#define WAKEUP							1
#define FALSE							0
#define TRUE							1

static int init_ecc_module(void);
static void cleanup_ecc_module(void);
static int vsc_ecc_create_file(unsigned long ,int );
static ssize_t show_ecc_reg(struct kobject *, struct attribute *,char *);
static ssize_t store_ecc_reg(struct kobject *,struct attribute *,const char *, size_t);
int vsc_ecc_thread(void * );
unsigned long vsc_ecc_read_reg(unsigned long );
void vsc_ecc_write_reg(unsigned long , int, unsigned long );
void print_ecc_reg(void);
static irqreturn_t ecc_int_handler ( int irq, void *dev_id );
static int vsc_ecc_ioctl(struct inode *inode, struct file *file,unsigned int cmd, unsigned long arg);
static int vsc_ecc_notify_sys(struct notifier_block *this, unsigned long code, void *unused);

